Sponsored Content
Special Forums UNIX and Linux Applications How to check if process is running? Post 302417072 by Corona688 on Wednesday 28th of April 2010 12:01:33 PM
Old 04-28-2010
A traditional way is for a process to create a PID file under /var/run/. I create it under /tmp/ just as an example that can run as any user. I also use a fifo as a lock file to prevent a race condition.

Code:
#!/bin/bash

function rm_pidfile
{
        rm -f /tmp/myscript.pid
}

function is_running
{
        # File does not exist, we can run
        [ -f /tmp/myscript.pid ] || return 1
        # Read PID from file
        read PID < /tmp/myscript.pid
        # File exists but process does not.
        [ -d /proc/${PID} ] || return 1
        return 0
}

# This guarantees other scripts will wait for each other
# before checking the pidfile.  otherwise one might create the PID
# file while we're not looking.
while ! mkfifo /tmp/myscript.lock 2> /dev/null
do
        sleep 1
done

# beyond this point, /tmp/myscript.lock exists and belongs to us.  Other
# instances of the script will loop.

if is_running
then
        echo "An instance(PID ${PID}) is already running"
        rm -f /tmp/myscript.lock
        exit 1
fi

# create PID file
echo "$$" > /tmp/myscript.pid

# make sure we delete it when the program quits
trap "rm_pidfile" EXIT

# Remove the lock file
rm -f /tmp/myscript.lock

# the rest of the code goes here

while true
do
        sleep 1
done

 

10 More Discussions You Might Find Interesting

1. Shell Programming and Scripting

How to check if another instance of the process is running

Hi, I am writing a shell script to invoke a C++ program. Before I start the C++ program (oi7loadbalancer), I am checking if the process is already running. I start the process only if it is not already running. I have the following check in my script. proccount=`ps -f -u $USER_NAME | grep... (8 Replies)
Discussion started by: sim
8 Replies

2. Shell Programming and Scripting

check process running

I have this script: ------------------------------------------------------- #!/bin/ksh # if ] || ] then echo "Executing main_load.sh script" /usr1/psc_load/jobs/cron/main_load.sh "ods" else echo "File not found, do nothing" fi exit 0 ... (4 Replies)
Discussion started by: rose1207
4 Replies

3. UNIX for Advanced & Expert Users

how to check how long the process has been running.

I have a requirement to check how long a process is running on unix system.If i use ps -ef i am getting the following message guest 2453638 1998920 0 16:16:05 - 0:00 dsapi_slave 9 8 0 but this is showing only time not the date.Can any one please advice me any script to find out how... (2 Replies)
Discussion started by: ukatru
2 Replies

4. UNIX for Advanced & Expert Users

How to check since when (for how long) a particular process is running ?

How do I check if a particular process is running from a certain date and time ? (2 Replies)
Discussion started by: hpuxlxboy
2 Replies

5. Shell Programming and Scripting

Check if Process is running

Hi , I have a csh code below which check the process if it's running. Can any expert advise me on the following: 1) what does this notationmean ">!" and how is it different from the append ">" notation ? 2) how does "setenv" work in this code ? # Check whether there is a running... (3 Replies)
Discussion started by: Raynon
3 Replies

6. UNIX for Dummies Questions & Answers

Command to check if a particular process is running

Hi What is the best command to check if a particular process is running in a linux server or not To check any java process, I use the below command. ps -ef |grep jvm When I execute the above command, it lists me all the processess . The above command should ideally return only the... (6 Replies)
Discussion started by: vr3w3c9
6 Replies

7. Programming

How do I check if a process is running in C

How to I check if a process is running in C? I'm trying to use ps aux |grep "process name" but failing in doing that. How do I do that? Thanks, (1 Reply)
Discussion started by: cprogdude
1 Replies

8. Shell Programming and Scripting

need to check if the process is running

Hi, I check if the process is running or not using the below. /usr/ucb/ps auxww | grep 109 |grep rmi | awk '{print $2}' 9718 Thus we see 9718 is the PID. It return blank if the process is not running. I need to perform some action if the process is not running and leave it if... (8 Replies)
Discussion started by: shifahim
8 Replies

9. UNIX for Dummies Questions & Answers

How a process can check if a particular process is running on different machine?

I have process1 running on one machine and generating some log file. Now another process which can be launched on any machine wants to know if process1 is running or not and also in case it is running it wants to stream the logs file generated by process1 on terminal from which process2 is... (2 Replies)
Discussion started by: saurabhnsit2001
2 Replies

10. Shell Programming and Scripting

Looping to check the currently running process.

Hi Gurus, t=`ps -u irb|grep -v grep|grep BSNL_PAYMENT_C` echo $t if then echo $? echo "Process Creation is Running ...." else echo "Process went down at $dat $tim" fi How would i use loop so that the script continously checks for the current status of this process.... (1 Reply)
Discussion started by: ankitknit
1 Replies
COM_GET_ACTIVE_OBJECT(3)						 1						  COM_GET_ACTIVE_OBJECT(3)

com_get_active_object - Returns a handle to an already running instance of a COM object

SYNOPSIS
variant com_get_active_object (string $progid, [int $code_page]) DESCRIPTION
com_get_active_object(3) is similar to creating a new instance of a "COM" object, except that it will only return an object to your script if the object is already running. OLE applications use something known as the " Running Object Table" to allow well-known applications to be launched only once; this function exposes the COM library function GetActiveObject() to get a handle on a running instance. PARAMETERS
o $progid -$progid must be either the ProgID or CLSID for the object that you want to access (for example Word.Application). o $code_page - Acts in precisely the same way that it does for the "COM" class. RETURN VALUES
If the requested object is running, it will be returned to your script just like any other COM object. ERRORS
/EXCEPTIONS There are a variety of reasons why this function might fail, the most common being that the object is not already running. In that situa- tion, the exception error code will be MK_E_UNAVAILABLE; you can use the getCode method of the exception object to check the exception code. NOTES
Warning Using com_get_active_object(3) in a web server context is not always a smart idea. Most COM/OLE applications are not designed to handle more than one client concurrently, even (or especially!) Microsoft Office. You should read Considerations for Server-Side Au- tomation of Office for more information on the general issues involved. PHP Documentation Group COM_GET_ACTIVE_OBJECT(3)
All times are GMT -4. The time now is 01:12 PM.
Unix & Linux Forums Content Copyright 1993-2022. All Rights Reserved.
Privacy Policy